package myfun

import (
	"fmt"

	"github.com/gin-gonic/gin"
)

func _send(c *gin.Context, msg string) {
	c.JSON(200, gin.H{
		"msg": msg,
	})
}

func Gin_OpenCom(c *gin.Context) {
	com_name := c.Query("c")
	if len(com_name) <= 0 {
		_send(c, "COM口异常")
		return
	}
	err := OpenPort(com_name)
	if err == nil {
		_send(c, "COM口打开成功!")
	} else {
		_send(c, err.Error())
	}
}

func Gin_LedOn(c *gin.Context) {
	_, err := SendAndRecv_bts([]byte{0x0f, 0x00})
	if err != nil {
		_send(c, err.Error())
	} else {
		_send(c, "开灯 - 操作成功")
	}
}

func Gin_LedOff(c *gin.Context) {
	_, err := SendAndRecv_bts([]byte{0x0f, 0xff})
	if err != nil {
		_send(c, err.Error())
	} else {
		_send(c, "关灯 - 操作成功")
	}
}

func Gin_Hello(c *gin.Context) {
	msg, err := SendAndRecv("hello")
	fmt.Println(msg)
	if err != nil {
		_send(c, err.Error())
	} else {
		_send(c, msg)
	}
}
